using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Globalization;

namespace Validierung
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class FormMain : System.Windows.Forms.Form
	{
		// my data
		int intValue;
		double doubleValue;

		// controls 
		private System.Windows.Forms.TextBox editText;
		private System.Windows.Forms.Label lblText;
		private System.Windows.Forms.Label lblInteger;
		private System.Windows.Forms.TextBox editInteger;
		private System.Windows.Forms.Label lblDouble;
		private System.Windows.Forms.TextBox editDouble;
		private System.Windows.Forms.Button btnClose;
		private System.ComponentModel.Container components = null;

		public FormMain()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		private void InitializeComponent()
		{
			this.editText = new System.Windows.Forms.TextBox();
			this.lblText = new System.Windows.Forms.Label();
			this.lblInteger = new System.Windows.Forms.Label();
			this.editInteger = new System.Windows.Forms.TextBox();
			this.lblDouble = new System.Windows.Forms.Label();
			this.editDouble = new System.Windows.Forms.TextBox();
			this.btnClose = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// editText
			// 
			this.editText.Location = new System.Drawing.Point(112, 16);
			this.editText.Name = "editText";
			this.editText.TabIndex = 1;
			this.editText.Text = "Text";
			// 
			// lblText
			// 
			this.lblText.Location = new System.Drawing.Point(8, 16);
			this.lblText.Name = "lblText";
			this.lblText.Size = new System.Drawing.Size(96, 20);
			this.lblText.TabIndex = 0;
			this.lblText.Text = "Text:";
			this.lblText.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// lblInteger
			// 
			this.lblInteger.Location = new System.Drawing.Point(8, 48);
			this.lblInteger.Name = "lblInteger";
			this.lblInteger.Size = new System.Drawing.Size(96, 20);
			this.lblInteger.TabIndex = 2;
			this.lblInteger.Text = "Integer:";
			this.lblInteger.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// editInteger
			// 
			this.editInteger.Location = new System.Drawing.Point(112, 48);
			this.editInteger.Name = "editInteger";
			this.editInteger.TabIndex = 3;
			this.editInteger.Text = "102";
			this.editInteger.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.editInteger.Validating += new System.ComponentModel.CancelEventHandler(this.editInteger_Validating);
			// 
			// lblDouble
			// 
			this.lblDouble.Location = new System.Drawing.Point(8, 80);
			this.lblDouble.Name = "lblDouble";
			this.lblDouble.Size = new System.Drawing.Size(96, 20);
			this.lblDouble.TabIndex = 4;
			this.lblDouble.Text = "Double:";
			this.lblDouble.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// editDouble
			// 
			this.editDouble.Location = new System.Drawing.Point(112, 80);
			this.editDouble.Name = "editDouble";
			this.editDouble.TabIndex = 5;
			this.editDouble.Text = "2E-4";
			this.editDouble.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.editDouble.Validating += new System.ComponentModel.CancelEventHandler(this.editDouble_Validating);
			// 
			// btnClose
			// 
			this.btnClose.Location = new System.Drawing.Point(132, 116);
			this.btnClose.Name = "btnClose";
			this.btnClose.Size = new System.Drawing.Size(80, 20);
			this.btnClose.TabIndex = 6;
			this.btnClose.Text = "Close";
			this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
			// 
			// FormMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(224, 149);
			this.Controls.Add(this.btnClose);
			this.Controls.Add(this.lblDouble);
			this.Controls.Add(this.editDouble);
			this.Controls.Add(this.editInteger);
			this.Controls.Add(this.editText);
			this.Controls.Add(this.lblInteger);
			this.Controls.Add(this.lblText);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "FormMain";
			this.Text = "Validierung";
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new FormMain());
		}

		bool IsValidInteger(string text, out int newValue)
		{
			newValue = 0;
			try 
			{
				intValue = int.Parse(text);
				return true;
			}
			catch
			{
				return false;
			}
		}

		bool IsValidDouble(string text, out double newValue)
		{
			newValue = 0.0;
			try 
			{
				newValue = double.Parse(text);
				return true;
			}
			catch
			{
				return false;
			}
		}

		private void editInteger_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			int newValue;
			if (IsValidInteger(editInteger.Text, out newValue))
			{
				intValue = newValue;
			}
			else
			{
				e.Cancel = true; 	// cancel validating -> go back to control
				MessageBox.Show("Enter an integer number!", "Error");
			}		
		}

		private void editDouble_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			double newDouble;
			if (double.TryParse(editDouble.Text, NumberStyles.Float, NumberFormatInfo.CurrentInfo, out newDouble))
			{
				doubleValue = newDouble;
			}
			else
			{
				e.Cancel = true;	// cancel validating -> go back to control
				MessageBox.Show("Enter a number!", "Error");
			}		
		}

		private void btnClose_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}
	}
}
